<template>
    <div class="label-create">
        <!-- <div class="row justify-start item-center q-pl-md-lg">
            <div class="col-12 q-ml-md-md font-18 text-black q-mt-lg">
                <q-btn flat no-caps @click="selectCurrentPage('default')">
                    <q-icon name="arrow_back" color="black" size="25px" />
                    <span class="font-18 helvetica-neue-medium q-pl-md">
                        {{ $t('button.back') }}
                    </span>
                </q-btn>
            </div>
        </div> -->

        <!-- title & save button -->
        <!-- <div class="row justify-center item-center">
            <div class="col-6 font-18 text-black q-mt-lg">
                {{ $t('preference.createRoles') }}
            </div>
            <div class="col-5 font-18 text-black q-mt-lg q-pl-md text-right">
                <q-btn
                    no-caps
                    color="green"
                    :label="$t('button.save')"
                    @click="updateRole"
                />
            </div>
        </div> -->

        <!-- Back Button, Title & Save Button -->
        <div class="row justify-center item-center q-py-md">
            <div
                class="
                    row
                    item-center
                    col-md-6 col-xs-7
                    font-18
                    text-black
                    q-mt-xs
                    update-label
                "
            >
                <q-btn
                    class="
                        q-pr-sm q-pl-lg-md q-pl-md-md q-pl-sm-md q-pl-xs-none
                    "
                    flat
                    no-caps
                    @click="selectCurrentPage('default')"
                >
                    <q-icon name="arrow_back" color="black" size="25px" />
                </q-btn>
                <div class="label-title-container helvetica-neue-medium">
                    {{ $t('preference.updateRoles') }} - {{ state.roles?.name }}
                </div>
            </div>
            <div
                class="
                    col-md-6 col-xs-5
                    q-pr-md-xl
                    font-18
                    text-black
                    q-mt-xs
                    text-right
                "
            >
                <q-btn
                    no-caps
                    text-color="white"
                    class="button-save"
                    :label="$t('button.save')"
                    @click="updateRole"
                />
            </div>
        </div>

        <!-- role -->
        <div class="row justify-center item-center">
            <div class="col-md-5 col-12 q-pl-md-xl q-mt-sm justify-center">
                <p class="font-14 q-mb-md helvetica-neue-medium">
                    {{ $t('preference.rolesName') }}
                    <span class="text-ff0000 font-10" v-if="!state.roles.name">
                        {{ $t('form.required') }}
                    </span>
                </p>
                <q-input
                    outlined
                    bottom-slots
                    dense
                    v-model="state.roles.name"
                    bg-color="blue-2"
                    class="border-radius-20"
                ></q-input>
            </div>
            <div
                class="
                    col-md-7 col-12
                    justify-center
                    q-pr-md-xl q-mt-sm q-pl-lg-xl q-pl-md-xl q-pl-xs-none
                "
            >
                <div class="row">
                    <p class="font-14 q-mb-md helvetica-neue-medium">
                        {{ $t('preference.roleColor') }}
                    </p>
                </div>
                <div class="row">
                    <div class="col-lg-2 col-md-3 col-xs-3 col-sm-3">
                        <div
                            class="
                                color-container
                                bg-666B72
                                items-center
                                row
                                justify-center
                                border-radius-10
                            "
                            :style="{
                                backgroundColor:
                                    state.roles?.color?.name ??
                                    state.roles.color
                            }"
                        >
                            <q-img
                                src="~assets/images/check.png"
                                width="20px"
                                height="20px"
                            />
                        </div>
                    </div>
                    <div class="col-lg-10 col-md-9 col-xs-9 col-sm-9">
                        <div
                            class="
                                q-ml-md q-mb-sm q-pa-md
                                color-container-mini
                                row
                                border-radius-10
                                pointer
                            "
                            :style="{
                                backgroundColor: color.name
                            }"
                            v-for="(color, index) in state.colors"
                            :key="'color-' + index"
                            @click="selectColor(color)"
                        ></div>
                    </div>
                </div>
            </div>
        </div>

        <!-- icons -->
        <div class="row justify-center item-center q-pt-md">
            <div class="col-11 justify-start">
                <p class="font-16 q-mb-md helvetica-neue-medium">
                    {{ $t('preference.permission') }}
                    <span
                        class="text-ff0000 font-10"
                        v-if="!state.permissionList"
                    >
                        {{ $t('form.required') }}
                    </span>
                </p>
            </div>
            <div class="col-11 justify-between">
                <div class="row justify-between items-center">
                    <div
                        class="
                            row
                            justify-between
                            items-left
                            auto-assign
                            col-lg-3 col-md-3 col-sm-4 col-xs-4
                            q-ma-sm
                        "
                        v-for="(type, index) in state.permissionList"
                        :key="index"
                    >
                        <div class="col-12 col-md-6 font-16 row items-center">
                            {{ type.name }}
                        </div>

                        <q-toggle
                            size="xl"
                            v-model="type.value"
                            color="green"
                            :true-value="1"
                            :false-value="0"
                        />
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script lang="ts">
import { useStore } from 'src/store';
import {
    defineComponent,
    ref,
    computed,
    watch,
    reactive,
    onMounted
} from 'vue';
import { MemberPermission } from 'src/services/enums/MemberPermission';
import { Roles } from 'src/services/models/Roles';

export default defineComponent({
    name: 'UpdateRole',
    props: {
        role: {
            type: Object as () => Roles,
            required: true
        }
    },
    setup(props, { emit }) {
        // computed
        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        const selectedBranch = computed(() => {
            return store.state.branch.branch;
        });

        // data
        let state = reactive({
            currentPage: 'default',
            roles: {} as any,
            loadingState: ref(false),
            toggleValue: {} as any,
            permissionList: [] as any,
            lists: [] as any,
            permissionOrder: '',
            colors: [
                {
                    id: 1,
                    name: '#4586E1'
                },
                {
                    id: 2,
                    name: '#8A6FF0'
                },
                {
                    id: 3,
                    name: '#FF6700'
                },
                {
                    id: 4,
                    name: '#46C883'
                },
                {
                    id: 5,
                    name: '#FFBB46'
                },
                {
                    id: 6,
                    name: '#FA6EAD'
                },
                {
                    id: 7,
                    name: '#29C5CE'
                },
                {
                    id: 8,
                    name: '#F09253'
                },
                {
                    id: 9,
                    name: '#F4656B'
                },
                {
                    id: 10,
                    name: '#7393C2'
                },
                {
                    id: 11,
                    name: '#C784AF'
                },
                {
                    id: 12,
                    name: '#00949D'
                }
            ],
            icons: [
                {
                    id: 1,
                    name: 'nightlight'
                },
                {
                    id: 2,
                    name: 'people'
                },
                {
                    id: 3,
                    name: 'campaign'
                }
            ]
        });
        const store = useStore();

        const selectCurrentPage = (page: string) => {
            emit('update-page', page);
        };
        const selectColor = (color: any) => {
            state.roles.color = color;
        };
        const getRoles = () => {
            state.roles = props.role;
            state.lists = MemberPermission;
            state.lists = Object.values(MemberPermission);

            if (state.lists) {
                state.lists.forEach((element: any) => {
                    let permission = {
                        name: element,
                        value: 0
                    };
                    state.permissionList.push(permission);
                });
                state.roles.permissions.forEach((element: any) => {
                    state.permissionList.forEach((role: any) => {
                        if (element == role.name) {
                            role.value = 1;
                        }
                    });
                });
            }
        };
        const updateRole = async () => {
            state.lists = [];
            await state.permissionList.forEach((element: any) => {
                if (element.value == 1) {
                    state.lists.push(element.name);
                }
            });
            if (state.lists) {
                let result = state.lists;

                if (state.roles.color?.name) {
                    state.roles.color = state.roles.color.name;
                }
                state.roles.permissions = result;
            }

            if (
                selectedBranch.value?.length != undefined ||
                selectedBranch.value
            ) {
                await store.dispatch('role/update', state.roles);
                const findBusinessIndex =
                    store.state.business.businesses.findIndex(
                        (element: any) => element.id == selectedBusinessId.value
                    );

                // only update permission list if agent account
                if (
                    !store.state.business.businesses[findBusinessIndex]?.member
                        .isOwner
                ) {
                    store.commit('role/updateRolePermission', state.roles);
                }

                emit('update-confirm', state.roles);
                emit('update-page', state.currentPage);
            } else {
                alert('kindly ask for branch list permission to proceed');
            }
        };

        onMounted(getRoles);
        return {
            state,
            store,
            dense: ref(true),
            getRoles,
            MemberPermission,
            selectColor,
            updateRole,
            selectCurrentPage
        };
    }
});
</script>
